Foreman - Feature #18675

Add telemetry to Foreman core
02/26/2017 10:00 AM - Lukas Zapletal

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Rails
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1537078 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5098,
https://github.com/theforeman/foreman/p
ull/5275,
https://github.com/theforeman/foreman-p
ackaging/pull/2233,
https://github.com/theforeman/foreman-p
ackaging/pull/2230
Description

Rails provides many instrumentation points which can be very easily hooked and exported to statsd and then to graph solutions or
monitoring. Protocol statsd is very simple, UDP based and provides decent integration options. This change will be unintrusive,

telemetry will be opt-in and it will be always disabled for test environment. It will also work without any external service sending the
telemetry data into Rails logger if needed.

This initial implementation provides Rails controller processing times for individual controllers and actions (view, db, total times in
ms). In addition, it provides number of success/failed login attempts, ActiveRecord instantianed classes, Foreman templates
rendering time and ActionMailer sent mail counts.

The only dependency introduced is pure-Ruby library "statsd-instrument" that provides client library for statsd daemon. The idea is to
run this daemon on localhost aggregating the data and/or sending to RRD or other monitoring solutions.

Related issues:

Related to Installer - Feature #23101: Expose telemetry parameters in setting...

Related to Discovery - Feature #22472: Add telemetry to discovery plugin

Related to Foreman - Bug #22764: Telemetry errors out with undefined method "...

Related to Foreman - Feature #22796: Add fact importing telemetry

Closed 04/03/2018
Ready For Testing

Closed 03/05/2018
Closed 03/06/2018

Associated revisions

Revision f020721d - 02/23/2018 12:38 PM - Lukas Zapletal

Fixes #18675 - telemetry foreman API

Revision 4093de10 - 02/26/2018 03:23 PM - Ewoud Kohl van Wijngaarden
Refs #18675 - Optionally load prometheus exporter

In case the bundler group telemetry is not installed, we should handle

that.

This moves the middleware loading to better match the other middleware.

Revision a5ac50ff - 02/26/2018 07:35 PM - Ewoud Kohl van Wijngaarden

Refs #18675 - Create a foreman-telemetry package

Also updates the nodejs dependencies.

Revision f6706bd7 - 02/26/2018 08:28 PM - Michael Moll

Refs #18675 - create foreman-telemetry package

05/22/2024

1/2




History

#1 - 02/26/2017 10:06 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Lukas Zapletal

- Pull request https://github.com/theforeman/foreman/pull/4336 added

#2 - 12/18/2017 01:24 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5096 added

#3 - 01/22/2018 12:04 PM - Bryan Kearney
- Bugzilla link set to 1537078

#4 - 02/05/2018 12:24 PM - Lukas Zapletal
- Pull request deleted (https://github.com/theforeman/foreman/pull/4336)

#5 - 02/23/2018 01:01 PM - Lukas Zapletal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset {020721dd1f1b7e3601a89ea5d2e0e9c0f4ceab8.

#6 - 02/23/2018 01:10 PM - Daniel Lobato Garcia

- translation missing: en.field_release set to 330

#7 - 02/26/2018 10:53 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5275 added

#8 - 02/26/2018 05:28 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman-packaging/pull/2233 added

#9 - 02/26/2018 05:53 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman-packaging/pull/2230 added

#10 - 04/03/2018 11:40 AM - Lukas Zapletal

- Related to Feature #23101: Expose telemetry parameters in settings.yaml added

#11 - 04/03/2018 11:41 AM - Lukas Zapletal
- Related to Feature #22472: Add telemetry to discovery plugin added

#12 - 04/03/2018 11:42 AM - Lukas Zapletal

- Related to Bug #22764: Telemetry errors out with undefined method '[]' for nil:NilClass on Rails code reload added

#13 - 04/03/2018 11:42 AM - Lukas Zapletal
- Related to Feature #22796: Add fact importing telemetry added
